﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FlexCel.Core;
using FlexCel.XlsAdapter;
using FlexCel.Report;

namespace CommentUDF
{
    class Program
    {
        static void Main(string[] args)
        {
            ExcelFile xls = new XlsFile("..\\..\\template.xlsx", true);
            using (FlexCelReport fr = new FlexCelReport(true))
            {
                fr.SetUserFunction("CommentUDF", new TCommentUDFImpl(xls));
                fr.Run(xls);
            }
                
            xls.Save("..\\..\\result.xlsx");

        }
    }

    class TCommentUDFImpl : TFlexCelUserFunction
    {
        ExcelFile Xls;

        public TCommentUDFImpl(ExcelFile aXls)
        {
            Xls = aXls;
        }

        private static void AddCommentAndResize(ExcelFile xls, double aspectRatio, int row, int col, TRichString text)
        {
            TCommentProperties comProps = TCommentProperties.CreateStandard(row, col, xls);
            comProps.Anchor = xls.AutofitComment(text, aspectRatio, true, 1.1, 10, comProps.Anchor);
            xls.SetComment(row, col, text, "", comProps);
        }
 
        public override object Evaluate(object[] parameters)
        {
            if (parameters == null || parameters.Length != 3)
                throw new ArgumentException("Bad parameter count in call to CommentUDF(row, col, comment) user-defined function");

            int row = Convert.ToInt32(parameters[0]);
            int col = Convert.ToInt32(parameters[1]);
            string text = Convert.ToString(parameters[2]);
            AddCommentAndResize(Xls, 3.0 / 4.0, row, col, text);
            return null;
        }
    }
}
